package com.fp.persistence.pgeneral.message;

import java.io.Serializable;
import java.lang.reflect.Field;

import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.Lob;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.persistence.Version;

import com.fp.dto.hb.HibernateBean;

/** Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEMESSAGETEMPLATESDESC */
@Entity(name = "TgeneMessageTemplatesDesc")
@Table(name = "TGENEMESSAGETEMPLATESDESC")
public class TgeneMessageTemplatesDesc extends com.fp.dto.AbstractDataTransport implements Serializable, HibernateBean, Cloneable {
    /**
     * HashCode asociado con la Instancia
     */
    @Transient
    private int hashValue = 0;

    /**
     * Version de la Clase
     */
    private static final long serialVersionUID = 1L;

    /**
     * Clave primaria de la Entidad TgeneMessageTemplatesDesc
     */
    @EmbeddedId
    private TgeneMessageTemplatesDescKey pk;

    @Version
    @Column(name = "RECORDVERSION", nullable = true)
    /**
     * Optimistick locking del registro
     */
    private Integer recordversion;

    @Column(name = "DESCRIPTION", nullable = true)
    /**
     * Descripcion default de la plantilla del mensaje
     */
    private String description;

    @Column(name = "TEMPLATE", nullable = true)
    /**
     * Plantilla del mensaje
     */
    private String template;

    /** Contructor por defecto */
    public TgeneMessageTemplatesDesc() {
    }

    /**
     * Contructor de TgeneMessageTemplatesDesc
     * 
     * @param pPk Clave Primaria del entity
     */
    public TgeneMessageTemplatesDesc(TgeneMessageTemplatesDescKey pPk) {
        this();
        this.pk = pPk;
    }

    /**
     * Metodo que entrega datos de la tabla dada la clave primaria.
     * 
     * @param pEntityManager referencia de la session a obtener datos del bean.
     * @param pKey Caleve primaria del bean.
     * @return TgeneMessageTemplatesDesc
     */
    public static TgeneMessageTemplatesDesc find(EntityManager pEntityManager, TgeneMessageTemplatesDescKey pKey) throws Exception {
        TgeneMessageTemplatesDesc obj = pEntityManager.find(TgeneMessageTemplatesDesc.class, pKey);
        return obj;
    }

    /**
     * Entrega la Clave primaria de TgeneMessageTemplatesDesc
     * 
     * @return El objeto que referencia a la Clave primaria de TgeneMessageTemplatesDesc
     */
    public TgeneMessageTemplatesDescKey getPk() {
        return this.pk;
    }

    /**
     * Fija un nuevo valor a la Clave primaria de TgeneMessageTemplatesDesc
     * 
     * @param pPk El objeto que referencia a la nueva Clave primaria de TgeneMessageTemplatesDesc
     */
    public void setPk(TgeneMessageTemplatesDescKey pPk) {
        this.pk = pPk;
    }

    /**
     * Obtiene el valor de recordversion
     * 
     * @return valor de recordversion
     */
    public Integer getRecordversion() {
        return this.recordversion;
    }

    /**
     * Fija el valor de recordversion
     * 
     * @param pRecordversion nuevo Valor de recordversion
     */
    public void setRecordversion(Integer pRecordversion) {
        this.recordversion = pRecordversion;
    }

    /**
     * Obtiene el valor de description
     * 
     * @return valor de description
     */
    public String getDescription() {
        return this.description;
    }

    /**
     * Fija el valor de description
     * 
     * @param pDescription nuevo Valor de description
     */
    public void setDescription(String pDescription) {
        this.description = pDescription;
    }

    /**
     * Obtiene el valor de template
     * 
     * @return valor de template
     */
    public String getTemplate() {
        return this.template;
    }

    /**
     * Fija el valor de template
     * 
     * @param pTemplate nuevo Valor de template
     */
    public void setTemplate(String pTemplate) {
        this.template = pTemplate;
    }

    @Override
    public boolean equals(Object rhs) {
        if (rhs == null) {
            return false;
        }
        if (!(rhs instanceof TgeneMessageTemplatesDesc)) {
            return false;
        }
        TgeneMessageTemplatesDesc that = (TgeneMessageTemplatesDesc) rhs;
        if ((this.getPk() == null) || (that.getPk() == null)) {
            return false;
        }
        return (this.getPk().equals(that.getPk()));
    }

    /**
     * Implementación del metodo hashCode de la la entidad TgeneMessageTemplatesDesc
     * 
     * @return el hashCode la instancia
     */
    @Override
    public int hashCode() {
        if (this.hashValue == 0) {
            int result = 17;
            if (this.getPk() == null) {
                result = super.hashCode();
            } else {
                result = this.getPk().hashCode();
            }
            this.hashValue = result;
        }
        return this.hashValue;
    }

    /** Implementación toString */
    @Override
    public String toString() {
        Field[] fs = this.getClass().getDeclaredFields();
        String data = "";
        for (Field f : fs) {
            try {
                String name = f.getName();
                if (f.getType().getName().compareTo("java.util.Set") == 0) {
                    continue;
                }
                if ((name.compareTo("hashValue") == 0) || (name.compareTo("serialVersionUID") == 0)) {
                    continue;
                }
                data += name + "=" + f.get(this) + ";";
            } catch (Exception e) {
                continue;
            }
        }
        if (data.compareTo("") == 0) {
            data = super.toString();
        }
        return data;
    }

    /** Implementación de la creación de un bean en blanco TgeneMessageTemplatesDesc */
    @Override
    public Object createInstance() {
        TgeneMessageTemplatesDesc instance = new TgeneMessageTemplatesDesc();
        instance.setPk(new TgeneMessageTemplatesDescKey());
        return instance;
    }

    /**
     * Clona la entidad TgeneMessageTemplatesDesc
     * 
     * @see com.fp.dto.hb.HibernateBean#cloneMe()
     */
    @Override
    public Object cloneMe() throws CloneNotSupportedException {
        TgeneMessageTemplatesDesc p = (TgeneMessageTemplatesDesc) this.clone();
        p.setPk((TgeneMessageTemplatesDescKey) this.pk.cloneMe());
        return p;
    }
}
